import { Form } from '../../e2elib/lib/src/pageobjects/form.component';
import { ListSOP } from '../../libappsop/listsop';
import { DialogExternalSupply } from '../dialogs/dialog.externalsupply';

export class FormExternalSupplies extends Form {
  public listExternalSupplies = new ListExternalSupplies();

  public constructor() {
    super('FormExternalSupplies');
  }
}

/**
 * Form used in supply costs view
 */
export class FormExternalSuppliesCost extends Form {
  public listExternalSupplies = new ListExternalSupplies();

  public constructor() {
    super('BaseFormExternalSupplies');
  }
}

class ListExternalSupplies extends ListSOP<DialogExternalSupply, ListExternalSuppliesColumn> {
  public readonly title = 'External Supplies';

  public constructor() {
    super('ListExternalSupplies', new DialogExternalSupply());

    // Set primary key column name(s), to display in error message when assert fails
    this.rowPrimaryColumnNames = {Date: '', Product: '', 'Stocking point': ''};
  }
}

export interface ListExternalSuppliesColumn {
  Date?: string;
  Product?: string;
  'Stocking point'?: string;
  Quantity?: string;
  Description?: string;
}

const listExternalSuppliesContextMenuItem = {
  Create: { ContextMenu: 'listContextMenuExternalSupplies', Name: 'MenuCreate', Label: 'Create' },
  Edit: { ContextMenu: 'listContextMenuExternalSupplies', Name: 'MenuEdit', Label: 'Edit' },
  Delete: { ContextMenu: 'listContextMenuExternalSupplies', Name: 'MenuDelete', Label: 'Delete' },
};

export { listExternalSuppliesContextMenuItem as ListExternalSuppliesContextMenuItem };
